#include "StdAfx.h"

#define SERVICE_NOT_PRESENT 0 

HOOKPROC hkprcSysMsg; 
static HHOOK hhookSysMsg; 

BOOL bCreated = FALSE;
BOOL UnloadProfile;
BOOL RebootNow = FALSE;
BOOL QuickReboot = FALSE;
BOOL run_setup = FALSE;
BOOL run_manager = FALSE;
ULONG Flags = 0;
BYTE* DllInjectorProc_addr = NULL;
SHUTDOWN_ACTION ShutdownAction = ShutdownReboot;
HWND hWndMain = NULL;

typedef struct _INJECTORARGS
{
  BYTE  puhandler_libraryname[MAX_PATH];
  BYTE  SetShutdownAction_name[MAX_PATH];
  DWORD LoadLibraryA;
  DWORD GetProcAddress;
  DWORD ExitThread;
  SHUTDOWN_ACTION ShutdownAction;
} INJECTORARGS;

//CHAR ShutdownScript[MAX_PATH] = "";
PCHAR ShutdownScript = NULL;;

BOOL RebootInitiated = FALSE;

#define FAST_REBOOT_APP_CLASS       TEXT("FastRebootAppClass")
#define FAST_REBOOT_SERVICE_NAME    TEXT("FastRebootService")
    
SERVICE_STATUS_HANDLE StatusHandle;

#pragma pack(push,1)
#pragma pack(1)


__declspec (naked)
ULONG
__stdcall
DllInjectorProc(PVOID ctx)
{
  _asm {
DllInjectorProc_in:
    mov     ebx, esp

    // get pointer to caller's context
    mov     eax, [ebx+4]
    or      eax, eax
    jnz     DllInjectorProc_LoadHook

    // get size of procedure
    lea     eax, DllInjectorProc_out
    mov     [DllInjectorProc_addr], offset DllInjectorProc_in
    sub     eax, offset DllInjectorProc_in

    push    eax
    call    dword ptr ExitThread

DllInjectorProc_LoadHook:

    // get ctx pointer
    mov     ebx, esp
    mov     ebx, [ebx+4]

    lea     eax, [ebx]INJECTORARGS.puhandler_libraryname
    push    eax // offset "PUHandler.dll"
    call    [ebx]INJECTORARGS.LoadLibraryA
    or      eax, eax
    jz      DllInjectorProc_err

    // get ctx pointer
    mov     ebx, esp
    mov     ebx, [ebx+4]

    lea     ecx, [ebx]INJECTORARGS.SetShutdownAction_name

    push    ecx // offset "SetShutdownAction"
    push    eax
    call    [ebx]INJECTORARGS.GetProcAddress
    or      eax, eax
    jz      DllInjectorProc_err

    // get ctx pointer
    mov     ebx, esp
    mov     ebx, [ebx+4]

    mov     ecx, [ebx]INJECTORARGS.ShutdownAction

    push    ecx
    call    eax

    push    0
    call    [ebx]INJECTORARGS.ExitThread

DllInjectorProc_err:

    push    -1
    call    [ebx]INJECTORARGS.ExitThread

DllInjectorProc_out:
  }
} // end DllInjectorProc()

/*struct INJECTORCODE
{
  // push     offset puhandler_libraryname
  BYTE  instr_push_loadlibrary_arg_1;
  DWORD loadlibrary_arg_1;

  // call     [LoadLibraryA]
  WORD  instr_call_loadlibrary_1;
  DWORD adr_from_call_loadlibrary_1;

  // call     [ExitThread]
  BYTE  instr_push_exitthread_arg;
  DWORD exitthread_arg;

  WORD  instr_call_exitthread;
  DWORD adr_from_call_exitthread;

  DWORD addr_loadlibrary;
  DWORD addr_exitthread;
  BYTE  puhandler_libraryname[MAX_PATH];
  BYTE  userenv_libraryname[MAX_PATH];
};*/

#pragma pack(pop,1)

/*
    Some parts from CRTL
*/
#define _TOLOWER(c) ( ((c) >= 'A') && ((c) <= 'Z') ? ((c) - 'A' + 'a') :\
              (c) )

size_t __cdecl wcslen (
        const wchar_t * wcs
        )
{
        const wchar_t *eos = wcs;

        while( *eos++ ) ;

        return( (size_t)(eos - wcs - 1) );
} // end wcslen()

int __cdecl memicmp (
        const void * first,
        const void * last,
        unsigned int count
        )
{
        int f = 0;
        int l = 0;

        while ( count-- )
        {
            if ( (*(unsigned char *)first == *(unsigned char *)last) ||
                 ((f = _TOLOWER( *(unsigned char *)first )) ==
                  (l = _TOLOWER( *(unsigned char *)last ))) )
            {
                first = (char *)first + 1;
                last = (char *)last + 1;
            }
            else
                break;
        }

        return ( f - l );
} // end memicmp()

PCHAR __cdecl strrchr (
        PCHAR string,
        CHAR ch
        )
{
        PCHAR start = (PCHAR)string;

        while (*string++)
                ;
        while (--string != start && *string != ch)
                ;

        if (*string == ch)
                return( (PCHAR)string );

        return(NULL);
} // strrchr()
/*
    End of CRTL parts
*/

ULONG (__stdcall *NtShutdownSystem) (
    IN SHUTDOWN_ACTION Action
);

ULONG (__stdcall *NtQuerySystemInformation) (
    ULONG   SystemInformationClass,
    PVOID   SystemInformation,
    ULONG   SystemInformationLength,
    PULONG  ReturnLength
);

typedef 
LPVOID (__stdcall *ptrVirtualAllocEx) (
  HANDLE hProcess,          // process to allocate memory
  LPVOID lpAddress,         // desired starting address 
  SIZE_T dwSize,            // size of region to allocate
  DWORD flAllocationType,   // type of allocation
  DWORD flProtect           // type of access protection
);

ptrVirtualAllocEx _VirtualAllocEx;

typedef 
BOOL (__stdcall *ptrVirtualFreeEx) (
  HANDLE hProcess,   // handle to process
  LPVOID lpAddress,  // starting address of memory region
  SIZE_T dwSize,     // size of memory region
  DWORD dwFreeType   // operation type
);

ptrVirtualFreeEx _VirtualFreeEx;

BOOL InjectDll(DWORD pid, char *lpszDllName/*, char *lpszDllNameUserEnv*/)
{
    HANDLE hProcess;
    BYTE* p_code;
    ULONG p_code_sz;
//    INJECTORCODE cmds;
    INJECTORARGS th_args;
    INJECTORARGS* pth_args;
    DWORD wr, id;
    HANDLE z;
//    HMODULE hDll;

    _VirtualAllocEx = (ptrVirtualAllocEx)GetProcAddress(GetModuleHandle("kernel32.dll"), "VirtualAllocEx");
    if(!_VirtualAllocEx)
        return FALSE;

    _VirtualFreeEx = (ptrVirtualFreeEx)GetProcAddress(GetModuleHandle("kernel32.dll"), "VirtualFreeEx");
    if(!_VirtualFreeEx)
        return FALSE;

    if(strlen(lpszDllName)>MAX_PATH) {
        return FALSE;
    }
    if(!pid)
        return FALSE;

    hProcess=OpenProcess(PROCESS_CREATE_THREAD|PROCESS_VM_WRITE|PROCESS_VM_OPERATION, FALSE, pid);

    if (hProcess == NULL)
        return FALSE;

    z = CreateThread(NULL, 0, DllInjectorProc, NULL, 0, &id);
    if(!z)
        return FALSE;
    WaitForSingleObject(z, INFINITE);
    p_code_sz = 0;
    GetExitCodeThread(z, &p_code_sz);
    CloseHandle(z);

    if(!p_code_sz)
        return FALSE;
    
    p_code = (BYTE*)_VirtualAllocEx(hProcess, 0, p_code_sz,
                                   MEM_COMMIT, PAGE_EXECUTE_READWRITE);
    if(p_code==NULL) {
        CloseHandle(hProcess);
        return FALSE;
    }
    pth_args = (INJECTORARGS*)_VirtualAllocEx(hProcess, 0, sizeof(th_args),
                                   MEM_COMMIT, PAGE_READWRITE);
    if(pth_args==NULL) {
        _VirtualFreeEx(hProcess, (void*)p_code, p_code_sz, MEM_RELEASE);
        CloseHandle(hProcess);
        return FALSE;
    }

    strcpy((char*)th_args.puhandler_libraryname, lpszDllName );
    strcpy((char*)th_args.SetShutdownAction_name, "SetShutdownAction");
    th_args.LoadLibraryA   = (DWORD)GetProcAddress(GetModuleHandle("kernel32.dll"), "LoadLibraryA");
    th_args.GetProcAddress = (DWORD)GetProcAddress(GetModuleHandle("kernel32.dll"), "GetProcAddress");
    th_args.ExitThread     = (DWORD)GetProcAddress(GetModuleHandle("kernel32.dll"), "ExitThread");
    th_args.ShutdownAction = ShutdownAction;

    if(!WriteProcessMemory(hProcess, p_code,   DllInjectorProc_addr, p_code_sz,       &wr) ||
       !WriteProcessMemory(hProcess, pth_args, &th_args,             sizeof(th_args), &wr)) {
        _VirtualFreeEx(hProcess, (void*)p_code,   p_code_sz,       MEM_RELEASE);
        _VirtualFreeEx(hProcess, (void*)pth_args, sizeof(th_args), MEM_RELEASE);
        CloseHandle(hProcess);
        return FALSE;
    }
    
    z = CreateRemoteThread(hProcess, NULL, 0, 
                 (unsigned long (__stdcall *)(void *))p_code, pth_args, 0, &id);
    if(!z) {
        _VirtualFreeEx(hProcess, (void*)p_code,   p_code_sz,       MEM_RELEASE);
        _VirtualFreeEx(hProcess, (void*)pth_args, sizeof(th_args), MEM_RELEASE);
        CloseHandle(hProcess);
        return FALSE;
    }

    WaitForSingleObject(z, INFINITE);
    CloseHandle(z);

    _VirtualFreeEx(hProcess, (void*)p_code,   p_code_sz,       MEM_RELEASE);
    _VirtualFreeEx(hProcess, (void*)pth_args, sizeof(th_args), MEM_RELEASE);
    CloseHandle(hProcess);

    return TRUE;
} // InjectDll()

typedef LONG    NTSTATUS;
typedef LONG    KPRIORITY;

#define STATUS_INFO_LENGTH_MISMATCH      (0xC0000004L)

#define SystemProcessesAndThreadsInformation    5

typedef struct _CLIENT_ID {
    DWORD         UniqueProcess;
    DWORD         UniqueThread;
} CLIENT_ID;
/*
typedef struct _UNICODE_STRING {
    USHORT        Length;
    USHORT        MaximumLength;
    PWSTR         Buffer;
} UNICODE_STRING;
*/
typedef struct _VM_COUNTERS {
    SIZE_T        PeakVirtualSize;
    SIZE_T        VirtualSize;
    ULONG         PageFaultCount;
    SIZE_T        PeakWorkingSetSize;
    SIZE_T        WorkingSetSize;
    SIZE_T        QuotaPeakPagedPoolUsage;
    SIZE_T        QuotaPagedPoolUsage;
    SIZE_T        QuotaPeakNonPagedPoolUsage;
    SIZE_T        QuotaNonPagedPoolUsage;
    SIZE_T        PagefileUsage;
    SIZE_T        PeakPagefileUsage;
} VM_COUNTERS;

typedef struct _SYSTEM_THREADS {
    LARGE_INTEGER KernelTime;
    LARGE_INTEGER UserTime;
    LARGE_INTEGER CreateTime;
    ULONG         WaitTime;
    PVOID         StartAddress;
    CLIENT_ID     ClientId;
    KPRIORITY     Priority;
    KPRIORITY     BasePriority;
    ULONG         ContextSwitchCount;
    LONG          State;
    LONG          WaitReason;
} SYSTEM_THREADS, * PSYSTEM_THREADS;

typedef struct _SYSTEM_PROCESSES {
    ULONG             NextEntryDelta;
    ULONG             ThreadCount;
    ULONG             Reserved1[6];
    LARGE_INTEGER     CreateTime;
    LARGE_INTEGER     UserTime;
    LARGE_INTEGER     KernelTime;
    UNICODE_STRING    ProcessName;
    KPRIORITY         BasePriority;
    ULONG             ProcessId;
    ULONG             InheritedFromProcessId;
    ULONG             HandleCount;
    ULONG             Reserved2[2];
    VM_COUNTERS       VmCounters;
#if _WIN32_WINNT >= 0x500
    IO_COUNTERS       IoCounters;
#endif
    SYSTEM_THREADS    Threads[1];
} SYSTEM_PROCESSES, * PSYSTEM_PROCESSES;

DWORD FindProcessPid(WCHAR *ImagePathName) {
    ULONG Status;
    ULONG cbBuffer = 0x8000;
    PVOID pBuffer = NULL;
    ULONG l=0;
    ULONG ImagePathNameLen = wcslen(ImagePathName)*sizeof(WCHAR);
    ULONG pid;

    NtQuerySystemInformation = (unsigned long (__stdcall *)(ULONG   SystemInformationClass,
                                                            PVOID   SystemInformation,
                                                            ULONG   SystemInformationLength,
                                                            PULONG  ReturnLength)) GetProcAddress( GetModuleHandle("ntdll.dll"), "NtQuerySystemInformation" );

    do {
        pBuffer = GlobalAlloc(GMEM_FIXED, cbBuffer);

        Status = NtQuerySystemInformation(
                    SystemProcessesAndThreadsInformation,
                    pBuffer, cbBuffer, NULL);

        if (Status == STATUS_INFO_LENGTH_MISMATCH) {
            GlobalFree(pBuffer);
            cbBuffer *= 2;
        }
    } while (Status == STATUS_INFO_LENGTH_MISMATCH ||
             Status != 0);

    PSYSTEM_PROCESSES pProcesses = (PSYSTEM_PROCESSES)pBuffer;

    for (;;) {
        if ((pProcesses->ProcessName.Length == ImagePathNameLen) &&
            (memicmp(pProcesses->ProcessName.Buffer,ImagePathName, ImagePathNameLen) == 0)) {
            pid = pProcesses->ProcessId;
            GlobalFree(pBuffer);
            return pid;
        }
        if(!pProcesses->NextEntryDelta)
            break;
        l += pProcesses->NextEntryDelta;
        if(l > cbBuffer)
            break;
        pProcesses = (PSYSTEM_PROCESSES)(((LPBYTE)pProcesses)
                        + pProcesses->NextEntryDelta);
        if(l+pProcesses->NextEntryDelta > cbBuffer)
            break;
    }

    GlobalFree(pBuffer);
    return 0;

} // end FindProcessPid()

#define STARTUP_STR "cmd.exe /C "

VOID
RunShutdownScript(
    PCHAR ShutdownScript
    )
{
    STARTUPINFO StartInfo;
    PROCESS_INFORMATION ProcessInfo;
    BOOL bProcessRet = false;    
    CHAR sCommandLine[MAX_PATH] = STARTUP_STR;

    ZeroMemory( &StartInfo, sizeof(StartInfo) );
    StartInfo.cb = sizeof(StartInfo);
    ZeroMemory( &ProcessInfo, sizeof(ProcessInfo) );

    sCommandLine[MAX_PATH-1] = 0;
    memcpy(sCommandLine+sizeof(STARTUP_STR)-1, ShutdownScript, strlen(ShutdownScript) );    
    bProcessRet = CreateProcess( NULL, sCommandLine, NULL, NULL, false, 
                                 NORMAL_PRIORITY_CLASS | CREATE_NO_WINDOW, NULL, NULL, 
                                 &StartInfo, &ProcessInfo );
    if (bProcessRet)
    {
        //WaitForSingleObject( ProcessInfo.hProcess, INFINITE );
        WaitForSingleObject(ProcessInfo.hProcess, 60*1000);

        CloseHandle( ProcessInfo.hProcess ); 
        CloseHandle( ProcessInfo.hThread );
    }
} // RunShutdownScript()

ULONG
__stdcall
RebootManager(PVOID);

ULONG
__stdcall
RebootImmediately(PVOID)
{
    WCHAR WinLogonName[MAX_PATH];
    CHAR PUHandlerPath[MAX_PATH];
    
    if(ShutdownScript[0]) {
        RunShutdownScript(ShutdownScript);
        //ShellExecute(hWndMain, "open", ShutdownScript, NULL, NULL, SW_SHOWNORMAL);
    }

    if (UnloadProfile) {
        wsprintfW(WinLogonName,L"winlogon.exe");

        if(!GetModuleFileName(NULL, PUHandlerPath, MAX_PATH))
            goto normal_shutdown;
        *(strrchr(PUHandlerPath, '\\') + 1) = '\0';
        strcat(PUHandlerPath,"PUHandler.dll");

        if(GainAllPrivileges()) {
            if(!InjectDll(FindProcessPid(WinLogonName),PUHandlerPath/*,UserEnvPath*/))
                goto normal_shutdown;
        }

normal_shutdown:

        ExitWindowsEx(Flags , 0);
        ExitThread(0);

    } else {
        GainAllPrivileges();
        NtShutdownSystem = (unsigned long (__stdcall *)(enum SHUTDOWN_ACTION_TAG)) GetProcAddress( GetModuleHandle("ntdll.dll"), "NtShutdownSystem" );
        NtShutdownSystem(ShutdownAction);
        ExitThread(0);
    }
    return 0;
} // RebootImmediately()


LRESULT CALLBACK
MyKeyboardProc(
    int nCode,     // hook code
    WPARAM wParam, // message identifier
    LPARAM lParam  // message data
) {
    if(nCode < 0 || RebootInitiated)
        return CallNextHookEx(hhookSysMsg, nCode, wParam, lParam);

    PKBDLLHOOKSTRUCT hookParams = (PKBDLLHOOKSTRUCT)lParam;

    if(wParam == WM_KEYDOWN || wParam == WM_SYSKEYDOWN) {
        if( 
            (GetAsyncKeyState(VK_SHIFT)   & 0x80000000) &&
            (GetAsyncKeyState(VK_CONTROL) & 0x80000000)  &&
            (GetAsyncKeyState(VK_MENU)    & 0x80000000)) {

            if(hook_qr && (hookParams->scanCode == 0x53)) {
                // Ctrl-Alt-Shift-Del
                RebootInitiated = TRUE;

                CreateThread(NULL, 0, RebootImmediately, NULL, 0, NULL);

                return 1;
            }
            if(hook_rm && (hookParams->scanCode == 0x46)) {
                // Ctrl-Alt-Shift-Break
                RebootInitiated = TRUE;

                CreateThread(NULL, 0, RebootManager, NULL, 0, NULL);

                return 1;
            }
        }
    }

    return CallNextHookEx(hhookSysMsg, nCode, wParam, lParam);
} // MyKeyboardProc()


LONG APIENTRY MainWndProc(
    HWND hWnd,                
    UINT message,             
    UINT wParam,              
    LONG lParam)              
{

    switch (message) 
    {
        case WM_CREATE:
            return 0;
 
        case WM_WINDOWPOSCHANGING:
            if (bCreated) {  
                LPWINDOWPOS lpwp;
               
                // correct WINDOWPOS parameters
                lpwp = (LPWINDOWPOS) lParam; // points to size and position data 
                lpwp->flags = SWP_NOMOVE    | SWP_NOOWNERZORDER |
                              SWP_NOSIZE | SWP_NOREDRAW | 
                              SWP_NOREPOSITION;

            } else { 
                bCreated = TRUE;
            }
            break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;

        default:
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (0);
} // MainWndProc()


BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS  wcSample;
    wcSample.style = 0;                     
    wcSample.lpfnWndProc = (WNDPROC)MainWndProc; 
    wcSample.cbClsExtra = 0;
    wcSample.cbWndExtra = 0;
    wcSample.hInstance = (HINSTANCE)hInstance;       
    wcSample.hIcon = NULL; 
    wcSample.hCursor = NULL;
    wcSample.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); 
    wcSample.lpszMenuName =  NULL;  
    wcSample.lpszClassName = FAST_REBOOT_APP_CLASS;

    return (RegisterClass(&wcSample));
} // end InitApplication()

/// Perofrom instance-specific intialization
BOOL InitInstance(
    HANDLE          hInstance,
    int             nCmdShow) 
{
    hWndMain = CreateWindow(
        FAST_REBOOT_APP_CLASS,
        TEXT("Fast Reboot Application"),
        WS_OVERLAPPEDWINDOW, 
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
        NULL,               
        NULL,               
        (HINSTANCE)hInstance,          
        NULL);

    if (!hWndMain)
        return (FALSE);

    ShowWindow(hWndMain, SW_HIDE);
//    ShowWindow(hWndMain, SW_SHOW);
    UpdateWindow(hWndMain); 
    return (TRUE);      

} // end InitInstance()

static const char help_text[] = 
    "Fast Reboot v3.2 (c) by Axxie & Alter, Home site http://www.alter.org.ua\n\n"
    "Usage:\n"
//    "\tfreboot\t[-<mode>|-?|-h] [-<switches>] [--<command1> [--<commnd2>]] [-<flags>]\n"
    "\tfreboot\t[-<mode>|-?|-h] [-<switches>] [--<command>] [-<flags>]\n"
    "Modes (are mutually exlusive):\n"
    "\t?\tshow this help\n\n"
    "\ti\treboot immediately\n"
    "\tq\tenable Quick Reboot mode (wait for Ctrl-Alt-Shift-Del)\n"
    "\tm\tenable Reboot Manager mode (wait for Ctrl-Alt-Shift-Break)\n"
    "\t \tby default standard shutdown/logof way is used (via ExitWindowsEx())\n"
    "\n"
    "Switches (are mutually exlusive):\n"
    "\tr\treboot\n"
    "\ts\tshutdown\n"
    "\tp\tpoweroff\n"
    "\tl\tlogoff (cannot be used with -q and -i)\n"
    "\n"
    "Commands:\n"
//    "\tsvc <service name>\tstop service named <service name> before reboot\n"
//    "\t\t\t\tif service name contains spaces, it must be quoted with \'\"\'\n"
//    "\t\t\t\tthis command can be used multiple times\n"
//    "\tsvcr <service reg-key>\tstop service defined by <service reg-key> before reboot\n"
//    "\t\t\t\tthis command can be used multiple times\n"
    "\tscript <script name>\truns script or executable <script name> before reboot.\n"
    "\tsetup\t\tdisplay GUI config tool\n"
    "\t\t\t\tNote, <script name> must be full path including drive letter\n"
    "\tg\t\trun BOOT.INI manager.\n"
    "\n"
    "Flags:\n"
    "\tf\tforce processes to terminate\n"
    "\tu\tunload user profile before Fast Reboot (is obsolet without -i or -q)\n"
    "\n"
    "Runs FastReboot setup if started without parameters.\n"
    "\n"
    "Installs FastReboot and optionally RebootManager Hook\n"
    "if started with -q and/or -m option.\n"
    "The FastReboot Hook enables functionality similar to Quick Reboot\n"
    "from Windows NT in 2000/XP/2003.\n"
    "The RebootManager Hook allows you to select OS where\n"
    "you are going to reboot to from BOOT.INI.\n"
    "You can use ALT+CTRL+SHIFT+BREAK to activate RebootManager\n"
    ;


VOID print_help(VOID) {

    HANDLE stdOuth = GetStdHandle(STD_OUTPUT_HANDLE);
    ULONG WrittenBytes;

    if(stdOuth && stdOuth != ((HANDLE)(-1))) {
        WriteFile(stdOuth, help_text, strlen(help_text), &WrittenBytes, NULL);
    } else {
        MessageBox(NULL, help_text, "Usage", MB_OK);
    }
} // end print_help()

/*SHUTDOWN_ACTION
APIENTRY
GetShutdownAction(
    VOID
    )
{
    return ShutdownAction;
}
*/

BOOLEAN
is_space(CHAR c) {
    if(c == ' ' || c == '\t')
        return TRUE;
    return FALSE;
} // end is_space()

BOOLEAN
is_space0(CHAR c) {
    if(c == ' ' || c == '\t' || !c)
        return TRUE;
    return FALSE;
} // end is_space()

int
get_fname(
    LPSTR     lpCmdLine
    )
{
    BOOLEAN break_on_q = FALSE;
    BOOLEAN break_name = FALSE;
    ULONG i;

    // skip name of executable
    if(lpCmdLine[0] == '\"') {
        // check if executable name comes in quotation marks
        break_on_q = TRUE;
    }
    // search for end of executable's name
    for (i=1; !break_name /*&& (i<lim-1)*/ ;i++) {
        switch(lpCmdLine[i]) {
        case '\"':
            break_name = TRUE;
            break;
        case 0:
            break_name = TRUE;
            break;
        case ' ':
        case '\t':
        case '\n':
        case '\r':
            if(!break_on_q) {
                break_name = TRUE;
            }
            break;
        }
    }
    return i;
} // end get_fname()

int skip_spaces(
    LPSTR     lpCmdLine
    )
{
    ULONG i;
    BOOLEAN break_name = FALSE;
    for (i=0; !break_name ;i++) {
        break_name = TRUE;
        switch(lpCmdLine[i]) {
        case ' ':
        case '\t':
        case '\n':
        case '\r':
            break_name = FALSE;
        }
        if(break_name)
            break;
    }
    return i;
} // end skip_spaces()

int check_if_started()
{
    if(FindWindow(FAST_REBOOT_APP_CLASS, NULL)) {
        return 1; 
    }
    return 0 ;
} // end check_if_started()

PCHAR
ReadRegCfg()
{
    HKEY hKey = NULL;
    ULONG res;
    ULONG i;
    PCHAR str;

    res = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_AUTORUN_STR, 0, KEY_ALL_ACCESS, &hKey);
    if(res != ERROR_SUCCESS) {
        res = GetLastError();
        return NULL;
    }
    str = (PCHAR)GlobalAlloc(GMEM_FIXED, 1024);
    i = 1024;
    res = RegQueryValueEx(hKey, "FastReboot", NULL, NULL, (PUCHAR)str, &i);
    if(res != ERROR_SUCCESS) {
        RegCloseKey(hKey);
        res = GetLastError();
        return NULL;
    }
    RegCloseKey(hKey);

    return str;
} // end ReadRegCfg()

BOOLEAN
ReadRegCfgRM()
{
    HKEY hKey = NULL;
    ULONG res;
    ULONG i;
    //PCHAR str;

    i = 0;
    res = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_PATH_ENV, 0, KEY_ALL_ACCESS, &hKey);
    if(res != ERROR_SUCCESS) {
        //printf("Can't access system environment variables\n");
    } else {
        i = sizeof(BootDrv);
        res = RegQueryValueEx(hKey, STR_BOOT_DRV_ENV_VAR, NULL, NULL, BootDrv, &i);
        if(res != ERROR_SUCCESS) {
            //printf("Can't setup SystemDrive system environment variable\n");
            i=0;
        } else {
        }
        RegCloseKey(hKey);
    }
    if(!i) {
        i = GetEnvironmentVariable(STR_BOOT_DRV_ENV_VAR, (PCHAR)BootDrv, sizeof(BootDrv));
    }
    if(!i) {
        BootDrv[0] = 0;
    }
    BootIniPath[0] = BootDrv[0];

    return i ? TRUE : FALSE;
} // end ReadRegCfgRM()

BOOLEAN
WriteRegCfgRM()
{
    HKEY hKey = NULL;
    ULONG res;
    ULONG i=0;
    //PCHAR str;

    res = SetEnvironmentVariable(STR_BOOT_DRV_ENV_VAR, (PCHAR)BootDrv);
    if(!res) {
        printf("Can't setup BootDrive environment variable\n");
    }
    res = RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_PATH_ENV, 0, KEY_ALL_ACCESS, &hKey);
    if(res != ERROR_SUCCESS) {
        printf("Can't access system environment variables\n");
    } else {
        res = RegSetValueEx(hKey, STR_BOOT_DRV_ENV_VAR, NULL, REG_SZ, BootDrv, 3);
        if(res != ERROR_SUCCESS) {
            printf("Can't setup SystemDrive system environment variable\n");
        } else {
            i = 1;
        }
        RegCloseKey(hKey);
    }

    BootIniPath[0] = BootDrv[0];

    return i ? TRUE : FALSE;
} // end WriteRegCfgRM()

int
parse_cmdline(
    LPSTR     lpCmdLine
    )
{
    ULONG i;
    ULONG lim;
    ULONG l;

    int cmd_ok = 0;

    lim = strlen(lpCmdLine);
    // skip name of executable
    i = get_fname(lpCmdLine);

    // set it empty
    ShutdownScript[0] = 0;

    // parse command line
    for (;i<lim ;i++) {
        // skip spaces/tabs
        if(lpCmdLine[i] == ' ' || lpCmdLine[i] == '\t')
            continue;
        // now we expect switches prepended with dash
        if(lpCmdLine[i] != '-') {
            print_help();
            return -1;
        }
        // skip dash
        i++;
        if(i>=lim) {
            print_help();
            return -1;
        }
        cmd_ok++;
        // parse switches after dash,
        // stop on speces/tabs
        for( ; (i<lim) && !(lpCmdLine[i] == ' ' || lpCmdLine[i] == '\t') ; i++) {
            switch(lpCmdLine[i]) {
                case '?' :
                case 'h' :
                    print_help();
                    return -1;
                case '-' :
                    i++;;
                    l = lim-i;
                    if(l >= sizeof("script")+1 &&
                       !memcmp(lpCmdLine+i, "script", sizeof("script")-1) &&
                       is_space(lpCmdLine[i+sizeof("script")-1])
                      ) {
                        // remember script name to execute before shutdown
                        i += sizeof("script");
                        i += skip_spaces(lpCmdLine+i);
                        l = get_fname(lpCmdLine+i);
                        l = min(MAX_PATH-1, l);
                        memcpy(ShutdownScript, lpCmdLine+i, l);
                        i += l;
                        ShutdownScript[l] = 0;
                    } else
                    if(l >= sizeof("setup")-1 &&
                       !memcmp(lpCmdLine+i, "setup", sizeof("setup")-1) &&
                       is_space0(lpCmdLine[i+sizeof("setup")-1])
                      ) {
                        // remember script name to execute before shutdown
                        i += sizeof("setup");
                        i += skip_spaces(lpCmdLine+i);
                        run_setup = TRUE;
                        cmd_ok--;
                    } else
                    if(l >= 10 &&
                       !memcmp(&lpCmdLine[i], "inst_svc", 8) &&
                       is_space(lpCmdLine[i+8])
                      ) {
                        // install as service. will handle hot-key even if user is not logged in
                        i += 8+1;
                        i += skip_spaces(lpCmdLine+i);
                    } else
                    if(l >= 10 &&
                       !memcmp(&lpCmdLine[i], "uninst_svc", 10) &&
                       is_space(lpCmdLine[i+10])
                      ) {
                        // uninstall service
                        i += 10+1;
                        i += skip_spaces(lpCmdLine+i);
                    } else {
                        print_help();
                        return -1;
                    }
                    break;
                case 'r' :
                    Flags |= EWX_REBOOT;
                    ShutdownAction = ShutdownReboot;
                    break;
                case 'q' :
                    QuickReboot = TRUE;
                    hook_qr = TRUE;
                    break;
                case 'm' :
                    hook_rm = TRUE;
                    break;
                case 'g' :
                    run_manager = TRUE;
                    break;
                case 'i' :
                    RebootNow = TRUE;
                    break;
                case 's' :
//                case 'h' :
                    Flags |= EWX_SHUTDOWN;
                    ShutdownAction = ShutdownNoReboot;
                    break;
                case 'l' :
                    Flags |= EWX_LOGOFF;
                    break;
                case 'p' :
                    Flags |= EWX_POWEROFF;
                    ShutdownAction = ShutdownPowerOff;
                    break;
                case 'f' :
                    Flags |= EWX_FORCE;
                    break;
                case 'u':
                    UnloadProfile = TRUE;
                    break;
                default:
                    print_help();
                    return -1;
            }
        }
    }

    return cmd_ok;
} // end parse_cmdline()

int
APIENTRY
WinMain(
    HINSTANCE hInstance,
    HINSTANCE hPrevInstance,
    LPSTR     lpCmdLine,
    int       nCmdShow
    )
{
    MSG msg;                       
    HANDLE th;
    int cmd_ok = 0;

    hInstance = 0;

    ShutdownScript = (PCHAR)GlobalAlloc(GMEM_FIXED, MAX_PATH);

    lpCmdLine = GetCommandLine();

    ReadRegCfgRM();
    if(!BootDrv[0]) {
        FindBootIni(NULL);
    }

    cmd_ok = parse_cmdline(lpCmdLine);
    if(cmd_ok == -1)
        return 0;

    if(!cmd_ok) {
        lpCmdLine = ReadRegCfg();
        if(lpCmdLine) {
            cmd_ok = parse_cmdline(lpCmdLine);
        } else {
            not_installed = TRUE;
            QuickReboot = TRUE;
            Flags = EWX_REBOOT | EWX_FORCE;
            ShutdownAction = ShutdownReboot;
            UnloadProfile = TRUE;
        }
    }
    if(!cmd_ok || run_setup) {
        FRSetup(hInstance, nCmdShow);
    }
    // default to -qrf[u]
    if(!Flags && !RebootNow && !QuickReboot) {
        if(check_if_started()) {
            if(!kill_by_caption(L"Fast Reboot Application"))
                return 1;
            Sleep(500);
        }
        QuickReboot = TRUE;
        Flags = EWX_REBOOT | EWX_FORCE;
        ShutdownAction = ShutdownReboot;
    }

    switch(Flags & (EWX_REBOOT | EWX_SHUTDOWN | EWX_POWEROFF | EWX_LOGOFF)) {
    case EWX_REBOOT:
    case EWX_SHUTDOWN:
    case EWX_POWEROFF:
    case EWX_LOGOFF:
        // all right, exclusivity is OK
        break;
    default:
        print_help();
        return 0;
    }

    // logoff cannot be used with -q and -i
    if(Flags & EWX_LOGOFF) {
        if(RebootNow || QuickReboot) {
            print_help();
            return 0;
        }
    }

    // -i and -q cannot be used together
    if(RebootNow && QuickReboot) {
        print_help();
        return 0;
    }

    // Run BOOT.INI manager (-g)
    if(run_manager) {
        if(RebootManager(NULL) == 1) {
            return 0;
        }
        if(!RebootInitiated)
            return 0;
    }

    // Reboot now (-i)
    if(RebootNow) {
        th = CreateThread(NULL, 0, RebootImmediately, NULL, 0, NULL);
        WaitForSingleObject(th, INFINITE);
        return 0;
    }

    // shutdown/logoff in normal way
    if (!QuickReboot) {
        GainAllPrivileges();
        ExitWindowsEx(Flags, 0);
        return 0;
    }

    // Install hook for Ctrl-Alt-Shift-Del (-q)
    if(check_if_started()) {
        return 1;
    }

    if (!InitApplication(hInstance))
        return (FALSE);     

    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    hhookSysMsg = SetWindowsHookEx(WH_KEYBOARD_LL,&MyKeyboardProc,GetModuleHandle(NULL),0);

    if(!hhookSysMsg) {
        int RC=GetLastError();
        ExitProcess(RC);
    }

    while (GetMessage(&msg, NULL, 0,0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg); 
    }

    UnhookWindowsHookEx(hhookSysMsg);
   
    return (msg.wParam);  
    
} // end WinMain()


