#ifndef __FR_COMMON__H__
#define __FR_COMMON__H__

typedef enum SHUTDOWN_ACTION_TAG {
    ShutdownNoReboot,
    ShutdownReboot,
    ShutdownPowerOff
} SHUTDOWN_ACTION;

// instance
extern HINSTANCE           hInst;
// main window
extern HWND                hMainDlg;

// General buffer for storing temporary strings
//static TCHAR        msgbuf[ 257 ];

// NT OS version
extern int NTVersion;

//CHAR g_Text[64*1024];

extern ULONG Flags;
extern SHUTDOWN_ACTION ShutdownAction;
extern BOOL  QuickReboot;
extern BOOL  UnloadProfile;
extern BOOL  hook_qr;
extern BOOL  hook_rm;
extern BOOL  not_installed;
extern PCHAR ShutdownScript;

int
//CALLBACK
FRSetup(
    HINSTANCE hInstance,
//    HINSTANCE hPrevInstance,
//    LPSTR lpCmdLine,
    int nCmdShow
    );

int
kill_by_caption(
    PWCHAR WinCap
    );

int check_if_started();

extern BOOL RebootInitiated;
extern UCHAR BootDrv[64];
extern UCHAR BootIniPath[];

#define REG_AUTORUN_STR "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run"
#define STR_BOOT_DRV_ENV_VAR "BootDrive"
#define REG_PATH_ENV "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment"

extern BOOLEAN FindBootIni(HWND hDlgItem);

extern BOOLEAN
WriteRegCfgRM();

#endif //__FR_COMMON__H__